#
# This is the SPEC file for creating binary RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, see <https://www.gnu.org/licenses/>.
#
#

Name:		qubes-core-qrexec
Version:	4.1.9
Release:	1%{dist}
Summary:	The Qubes qrexec files (common files)

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

BuildRequires:	gcc
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:	python%{python3_pkgversion}-dbus
# for building documentation
BuildRequires:	python%{python3_pkgversion}-sphinx
BuildRequires:	python%{python3_pkgversion}-recommonmark
BuildRequires:	qubes-libvchan-devel
BuildRequires:  python%{python3_pkgversion}-rpm-macros

Requires:   python%{python3_pkgversion}
Requires:   python%{python3_pkgversion}-gbulb
Conflicts:  qubes-utils-libs < 4.1.0
Conflicts:  qubes-core-agent-qrexec < 4.1.0
Conflicts:  qubes-core-dom0 < 4.1.10
Conflicts:  qubes-core-dom0-linux < 4.1.5
Conflicts:  qubes-gui-agent < 4.1.6
Conflicts:  qubes-gpg-split < 2.0.45
Conflicts:  qubes-gui-daemon < 4.1.4
Conflicts:  qubes-input-proxy < 1.0.17
Conflicts:  qubes-pdf-converter < 2.1.7
Conflicts:  qubes-usb-proxy < 1.0.28

Source0: qubes-core-qrexec-%{version}.tar.gz

%description
The Qubes qrexec files for installation on both dom0 and qube.

%package libs
Summary:    Libraries for qubes-qrexec
Conflicts:  qubes-utils-libs < 4.1.0

%description libs
Libraries for qubes-qrexec

%package devel
Summary:    Development headers for qubes-qrexec
Requires:   %{name}-libs

%description devel
Development header and files for qubes-qrexec

%prep
%setup -qn qubes-core-qrexec-%{version}

%build
%{?set_build_flags}
export BACKEND_VMM=xen
make all-base PYTHON=%{__python3}
make -C doc PYTHON=python3 SPHINXBUILD=sphinx-build-3 man

%install
make install-base \
    INCLUDEDIR=%{_includedir} \
    LIBDIR=%{_libdir} \
    SYSCONFDIR=%{_sysconfdir} \
    UNITDIR=%{_unitdir} \
    PYTHON_SITEPATH=%{python3_sitelib} \
    PYTHON=%{__python3} \
    DESTDIR=$RPM_BUILD_ROOT

make -C doc \
    DESTDIR=$RPM_BUILD_ROOT \
    SPHINXBUILD=sphinx-build-3 \
    install

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%files
%defattr(-,root,root,-)

%{_bindir}/qrexec-policy-exec
%{_bindir}/qrexec-policy-agent
%{_bindir}/qrexec-policy-graph
%{_bindir}/qrexec-policy-restore
%{_bindir}/qrexec-policy-daemon
%{_bindir}/qubes-policy
%{_bindir}/qubes-policy-admin
%{_bindir}/qrexec-policy

/usr/lib/qubes/qubes-rpc-multiplexer
/usr/lib/qubes/qrexec-policy-agent-autostart

%{_sysconfdir}/qubes-rpc/policy.Ask
%{_sysconfdir}/qubes-rpc/policy.Notify

%{_sysconfdir}/xdg/autostart/qrexec-policy-agent.desktop

%dir %{python3_sitelib}/qrexec-*.egg-info
%{python3_sitelib}/qrexec-*.egg-info/*

%dir %{python3_sitelib}/qrexec
%dir %{python3_sitelib}/qrexec/__pycache__
%{python3_sitelib}/qrexec/__pycache__/*
%{python3_sitelib}/qrexec/__init__.py
%{python3_sitelib}/qrexec/client.py
%{python3_sitelib}/qrexec/exc.py
%{python3_sitelib}/qrexec/utils.py
%{python3_sitelib}/qrexec/server.py

%dir %{python3_sitelib}/qrexec/policy
%dir %{python3_sitelib}/qrexec/policy/__pycache__
%{python3_sitelib}/qrexec/policy/__pycache__/*
%{python3_sitelib}/qrexec/policy/__init__.py
%{python3_sitelib}/qrexec/policy/admin.py
%{python3_sitelib}/qrexec/policy/admin_client.py
%{python3_sitelib}/qrexec/policy/parser.py
%{python3_sitelib}/qrexec/policy/parser_compat.py
%{python3_sitelib}/qrexec/policy/utils.py

%dir %{python3_sitelib}/qrexec/tools
%dir %{python3_sitelib}/qrexec/tools/__pycache__
%{python3_sitelib}/qrexec/tools/__pycache__/*
%{python3_sitelib}/qrexec/tools/__init__.py
%{python3_sitelib}/qrexec/tools/qubes_policy.py
%{python3_sitelib}/qrexec/tools/qubes_policy_admin.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_agent.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_exec.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_daemon.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_graph.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_restore.py

%dir %{python3_sitelib}/qrexec/tests
%dir %{python3_sitelib}/qrexec/tests/__pycache__
%{python3_sitelib}/qrexec/tests/__pycache__/*
%{python3_sitelib}/qrexec/tests/__init__.py
%{python3_sitelib}/qrexec/tests/cli.py
%{python3_sitelib}/qrexec/tests/gtkhelpers.py
%{python3_sitelib}/qrexec/tests/rpcconfirmation.py
%{python3_sitelib}/qrexec/tests/policy_parser.py
%{python3_sitelib}/qrexec/tests/qrexec_policy_daemon.py
%{python3_sitelib}/qrexec/tests/policy_cache.py
%{python3_sitelib}/qrexec/tests/server.py
%{python3_sitelib}/qrexec/tests/policy_admin.py

%dir %{python3_sitelib}/qrexec/tests/socket
%dir %{python3_sitelib}/qrexec/tests/socket/__pycache__
%{python3_sitelib}/qrexec/tests/socket/__pycache__/*
%{python3_sitelib}/qrexec/tests/socket/__init__.py
%{python3_sitelib}/qrexec/tests/socket/agent.py
%{python3_sitelib}/qrexec/tests/socket/daemon.py
%{python3_sitelib}/qrexec/tests/socket/qrexec.py
%{python3_sitelib}/qrexec/tests/socket/util.py

%dir %{python3_sitelib}/qrexec/glade
%{python3_sitelib}/qrexec/glade/RPCConfirmationWindow.glade

%{_datadir}/man/man1/qubes-core-qrexec.1.gz

%files devel
%{_includedir}/qrexec.h
%{_includedir}/libqrexec-utils.h

%files libs
%{_libdir}/libqrexec-utils.so*

%changelog
* Sat Oct 10 2020 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-core-qrexec.git

* Sat Oct 10 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 1f5740e
- version 4.1.9

* Sat Oct 10 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - bea8916
- Fix handling default_target in ask action

* Sun Sep 20 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 68b8b65
- Fix sphinx build

* Sun Sep 20 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - eeda500
- Fix documentation build

* Mon Aug 31 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - a69f12f
- Handle Pylint upgrade

* Mon Aug 31 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - cc965dc
- policy admin: add default configuration

* Tue Aug 25 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 926f618
- policy admin: package

* Tue Aug 25 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 28fc52b
- policy admin: add client API and command-line tool

* Tue Aug 25 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 36703b7
- policy admin: add tokens to prevent concurrent modification

* Tue Aug 25 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 0548a54
- policy admin: change API to use policy.include.*

* Tue Aug 25 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 981f74d
- Add a QubesRPC API for policy

* Tue Aug 11 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 24635ad
- travis: restore language option

* Fri Aug 07 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 199c300
- Update travis

* Fri Jul 24 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 3aa595d
- policy: allow '*' as source and target

* Thu Jul 23 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 39f63f9
- Add 'autostart=no' option to policy

* Thu Jul 16 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 79e6bd0
- policy: interpret invalid requested target as @default

* Sun May 24 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ea0e776
- version 4.1.8

* Sun May 24 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ab7fd0f
- rpm: adjust depencency on qubes-core-dom0

* Fri May 15 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ffba26f
- Update qrexec-policy-graph tool for new qrexec module

* Fri May 15 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9dc5032
- parser: ignore .rpmsave/.rpmnew/.swp and .* policy files...

* Fri May 15 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b7cb638
- Fix documentation for relative paths in !include directive

* Mon May 04 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b6ae0d4
- Revert "test: downgrade pytest-asyncio"

* Sun May 03 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c71e6fa
- rpm: restart qrexec-policy-daemon on upgrade

* Sun May 03 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - bba3d33
- Update for changed qubesd socket protocol

* Sun May 03 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4606fc4
- test: downgrade pytest-asyncio

* Sat May 02 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0877bbe
- Fix dangerous-default-value pylint warning

* Sat Apr 04 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4fa17c9
- version 4.1.7

* Wed Apr 01 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - a24a446
- spec: fix hardcoded python3 prefix for CentOS

* Tue Mar 31 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 4dc330b
- Remove false error message on vchan disconnect

* Tue Mar 31 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8ffe427
- Adjust dependencies to avoid breaking USB proxy

* Mon Mar 30 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 323c19b
- fuzzer: use C++ compiler for linking

* Mon Mar 30 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 817f9f0
- policy/utils: fix pyinotify cleanup

* Sat Mar 28 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 5fdd524
- qrexec-agent, qrexec-daemon: unblock signals before exec()

* Sat Mar 28 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - c9b3439
- qrexec-client: handle failed service exec

* Sat Mar 28 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 97373fa
- version 4.1.6

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 7f6d27b
- travis: add job names, add fuzzer

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - c7ce579
- qrexec-policy-agent: always show service argument

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 868b265
- policy-agent: use autostart program, not systemd service

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 1206fe3
- Support wait-for-session in dom0

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - f952240
- Factor out parsing service configuration

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 2c1e737
- Add a requirement for qubes-core-dom0 version >= 4.1.9

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 64935af
- Clean up call() and call_async()

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 2f6721d
- Refactor socket service handling

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - c9962fd
- Document qrexec-policy-agent API

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 51d1d09
- Add a test for no-GuiVM notifications

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 661e318
- qrexec-policy-daemon: don't reply with result=allow before execution

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 8467bb3
- Change format for 'ask' response

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 49e1240
- qrexec-policy-exec: handle 'execution failed' corner case

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - 11835e1
- qrexec-policy-exec: recover from failure when notifying

* Fri Mar 27 2020 Paweł Marczewski <pawel@invisiblethingslab.com> - c50a2e0
- Refactor socket server into a more reusable SocketService class

